﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.IO;
using Infragistics.Imaging;
using System.Windows.Media.Imaging;
using Infragistics.Documents.Excel;

namespace XamPieChart_to_image
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {

            WriteableBitmap writablebmp = new WriteableBitmap(gridContainer, null);

            writablebmp.Invalidate();

            Workbook workbook1 = new Workbook();
            Worksheet ws1 = workbook1.Worksheets.Add("Chart Sheet");


            int width = (int)this.gridContainer.ActualWidth;
            int height = (int)this.gridContainer.ActualHeight;


            SaveFileDialog savefileDialog = new SaveFileDialog { Filter = "Excel files|*.xls", DefaultExt = "xls" };

            if (savefileDialog.ShowDialog() == true)
            {
                Stream stream = savefileDialog.OpenFile();
                PngImageEncoder encoder = new PngImageEncoder();


                WorksheetImage imageShape = new WorksheetImage(writablebmp, encoder, null);

                int cellIndex = width / 65;
                int rowIndex = height / 18;

                imageShape.TopLeftCornerCell = ws1.Rows[0].Cells[0];
                imageShape.TopLeftCornerPosition = new Point(0.0F, 0.0F);

                imageShape.BottomRightCornerCell = ws1.Rows[rowIndex + 1].Cells[cellIndex + 1];
                imageShape.BottomRightCornerPosition = new Point(100.0F, 100.0F);

                ws1.Shapes.Add(imageShape);

                workbook1.Save(stream);
                stream.Close();
            }
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            WriteableBitmap writablebmp = new WriteableBitmap(gridContainer, null);

            writablebmp.Invalidate();

            int width = (int)this.gridContainer.ActualWidth;
            int height = (int)this.gridContainer.ActualHeight;

            SaveFileDialog savefileDialog = new SaveFileDialog { Filter = "Png Image (.png)|*.png", DefaultExt = "png" };

            if (savefileDialog.ShowDialog() == true)
            {
                using (Stream stream = savefileDialog.OpenFile())
                {
                    PngImageEncoder encoder = new PngImageEncoder();

                    encoder.Encode(writablebmp, null, stream);
                }
            }
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            WriteableBitmap writablebmp = new WriteableBitmap(gridContainer, null);

            writablebmp.Invalidate();

            int width = (int)this.gridContainer.ActualWidth;
            int height = (int)this.gridContainer.ActualHeight;

            SaveFileDialog savefileDialog = new SaveFileDialog { Filter = "Jpeg Image (.jpg)|*.jpg", DefaultExt = "png" };

            if (savefileDialog.ShowDialog() == true)
            {
                using (Stream stream = savefileDialog.OpenFile())
                {
                    JpegImageEncoder encoder = new JpegImageEncoder();

                    encoder.Encode(writablebmp, null, stream);
                }
            }
        }








    }

    public class DataItem
    {
        public string Label { get; set; }
        public double Value { get; set; }
    }

    public class Data : ObservableCollection<DataItem>
    {
        public Data()
        {
            Add(new DataItem { Label = "Rihanna", Value = 5 });
            Add(new DataItem { Label = "Beyonce", Value = 6 });
            Add(new DataItem { Label = "Katy Perry", Value = 3 });
            Add(new DataItem { Label = "Lady Gaga", Value = 7 });
            Add(new DataItem { Label = "Adele", Value = 5 });
        }
    }
}
